#ifndef qbTokensHH
#define qbTokensHH

#include <string>

enum QBtoken
{

/*  scroll down. empty lines have been inserted
 *  to make it easy to look up token numbers from
 *  the source (line number = token number)
 */






















    HASHSYM = 35,




    OPENPARENS = 40,
    CLOSEPARENS = 41,
    ASTERISK = 42,
    PLUS = 43,
    COMMA = 44,
    MINUS = 45,
    PERIOD = 46,
    SLASH = 47,











    SEMICOLON = 59,
    LESSTHAN = 60,
    EQUALS = 61,
    GREATERTHAN = 62,





























    BKSLASH = 92,

    CIRCUMFLEX = 94,


































































































































































    ABS = 256,
    ACCESS,
    ALIAS,
    AND,
    ANY,
    APPEND,
    AS,
    ASC,
    ATN,
    BASE,
    BEEP,
    BINARY,
    BYVAL,
    CALL,
    CASE,
    CDBL,
    CDECL,
    CHDIR,
    CHR_S,
    CINT,
    CIRCLE,
    CLEAR,
    CLNG,
    CLOSE,
    CLS,
    COLONCHAR,
    COLOR,
    COMMAND_S,
    COMMON,
    CONST,
    COS,
    CRLF,
    CSNG,
    CSRLIN,
    CVD,
    CVI,
    CVL,
    CVS,
    DATA,
    DATE_S,
    DECLARE,
    DEF,
    DEFSEG,
    DIM,
    DO,
    DOUBLE,
    DRAW,
    ELSE,
    ELSEIF,
    END,
    ENDDEF,
    ENDFUNCTION,
    ENDIF,
    ENDSELECT,
    ENDSUB,
    ENDTYPE,
    ENVIRON_S,
    EQV,
    ERASE,
    ERL,
    ERR,
    ERROR,
    EXIT,
    EXITDEF,
    EXITDO,
    EXITFOR,
    EXITFUNCTION,
    EXITSUB,
    EXP,
    FIELD,
    FILEATTR,
    FILES,
    FIX,
    FNIDENTIFIER,
    FOR,
    FRE,
    FREEFILE,
    FUNCTION,
    GET,
    GOSUB,
    GOTO,
    GREATEROREQUAL,
    HEX_S,
    IDENTIFIER,
    IF,
    IMP,
    INKEY_S,
    INP,
    INPUT,
    INPUT_S,
    INSTR,
    INT,
    INTEGER,
    IS,
    KEY,
    KILL,
    LBOUND,
    LCASE_S,
    LEFT_S,
    LEN,
    LESSOREQUAL,
    LET,
    LINE,
    LINE_INPUT,
    LIST,
    LOC,
    LOCATE,
    LOCK,
    LOF,
    LOG,
    LONG,
    LOOP,
    LPOS,
    LPRINT,
    LSET,
    LTRIM_S,
    MID_S,
    MKDIR,
    MKD_S,
    MKI_S,
    MKL_S,
    MKS_S,
    MOD,
    NEXT,
    NOISE,
    NOT,
    NOTEQUAL,
    NUMBER,
    OCT_S,
    OFF,
    ON,
    ON_ERROR,
    ON_KEY,
    ON_PLAY,
    ON_TIMER,
    OPEN,
    OPTION,
    OR,
    OUT,
    OUTPUT,
    PAINT,
    PALETTE,
    PALETTE_USING,
    PEEK,
    PLAY,
    PMAP,
    POINT,
    POKE,
    POS,
    PRESET,
    PRINT,
    PSET,
    PUT,
    RANDOM,
    RANDOMIZE,
    READ,
    REDIM,
    REM,
    RESTORE,
    RESUME,
    RESUME_NEXT,
    RETURN,
    RIGHT_S,
    RMDIR,
    RND,
    RSET,
    RTRIM_S,
    SCREEN,
    SEEK,
    SEG,
    SELECT,
    SGN,
    SHARED,
    SHELL,
    SIN,
    SINGLE,
    SLEEP,
    SOUND,
    SPACE_S,
    SPC,
    SQR,
    STATIC,
    STEP,
    STOP,
    STRING,
    STRINGCONST,
    STRING_S,
    STR_S,
    SUB,
    SWAP,
    SYSTEM,
    TAB,
    TAN,
    THEN,
    TIMER,
    TIME_S,
    TO,
    TYPE,
    UBOUND,
    UCASE_S,
    UNTIL,
    USING,
    VAL,
    VARPTR,
    VARPTR_S,
    VARSEG,
    VIEW,
    VIEW_PRINT,
    WAIT,
    WEND,
    WHILE,
    WIDTH,
    WIDTH_F,
    WIDTH_LPRINT,
    WINDOW,
    WRITE,
    XOR,
    metaDYNAMIC,
    metaSTATIC,
    qb64BIT,
    qbcBIN_S,
    qb64BYTE,
    qb64DEFINE,
    qb64DISPLAY,
    qb64DONTBLEND,
    qb64KEYDOWN,
    qb64NEWIMAGE,
    qb64UNSIGNED,
    qb64UNSIGNEDBIT,
    qb64UNSIGNEDBYTE,
    qb64UNSIGNEDINTEGER,
    qb64UNSIGNEDLONG,
    qb64SNDBAL,
    qb64SNDCLOSE,
    qb64SNDCOPY,
    qb64SNDOPEN,
    qb64SNDPAUSE,
    qb64SNDPAUSED,
    qb64SNDPLAY,
    qb64SNDPLAYCOPY,
    qb64SNDPLAYING,
    qb64SNDRATE,
    qb64SNDRAW,
    qb64SNDRAWDONE,
    qb64SNDRAWLEN,
    qb64SNDRAWOPEN,
    qb64SNDSTOP,
    qbcSHL,
    qbcSHR,
    qbcASIN,
    qbcACOS,
    qbcSINH,
    qbcCOSH,
    qbcTANH,
    qbcASINH,
    qbcACOSH,
    qbcATANH,
    qbcATAN2
};

const std::string GetTokenName(QBtoken tok);

#endif
