#include <typeinfo>

#ifdef __GNUC__
# include <cxxabi.h>
#endif

template<typename T>
const std::string typenameof(const T& t)
{
    if((const void*)&t == nullptr) return "(null)";
    const std::type_info& p = typeid(t);
    return "_Z" + std::string(p.name());
#ifdef __GNUC__
    char Buf[16384];
    std::size_t len = sizeof(Buf);
    int status=0;
    __cxxabiv1::__cxa_demangle(p.name(), Buf, &len, &status);
    return Buf;
#endif
}
